added one-liner for easy copy/paste
[gnt-info] / init.d / gnt-monitor
1 #! /bin/sh
2 ### BEGIN INIT INFO
3 # Provides:          gnt-monitor
4 # Required-Start:    $remote_fs $syslog $ganeti
5 # Required-Stop:     $remote_fs $syslog $ganeti
6 # Default-Start:     2 3 4 5
7 # Default-Stop:      0 1 6
8 # Short-Description: Example initscript
9 # Description:       This file should be used to construct scripts to be
10 #                    placed in /etc/init.d.
11 ### END INIT INFO
12
13 # Author: Foo Bar <foobar@baz.org>
14 #
15 # Please remove the "Author" lines above and replace them
16 # with your own name if you copy and modify this script.
17
18 # Do NOT "set -e"
19
20 # PATH should only include /usr/* if it runs after the mountnfs.sh script
21 PATH=/sbin:/usr/sbin:/bin:/usr/bin
22 DESC="Genti monitor"
23 NAME=gnt-monitor
24 DAEMON=/etc/ganeti/$NAME
25 DAEMON_ARGS=""
26 PIDFILE=/var/run/$NAME.pid
27 SCRIPTNAME=/etc/init.d/$NAME
28
29 # Exit if the package is not installed
30 [ -x "$DAEMON" ] || exit 0
31
32 # Read configuration variable file if it is present
33 [ -r /etc/default/$NAME ] && . /etc/default/$NAME
34 export DEBUG
35 export INFLUX
36 export INTERVAL
37 export DC
38 export RACK
39
40 # Load the VERBOSE setting and other rcS variables
41 . /lib/init/vars.sh
42
43 # Define LSB log_* functions.
44 # Depend on lsb-base (>= 3.2-14) to ensure that this file is present
45 # and status_of_proc is working.
46 . /lib/lsb/init-functions
47
48 #
49 # Function that starts the daemon/service
50 #
51 do_start()
52 {
53         # Return
54         #   0 if daemon has been started
55         #   1 if daemon was already running
56         #   2 if daemon could not be started
57         #start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
58         #       || return 1
59         start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --background --make-pidfile -- \
60                 $DAEMON_ARGS \
61                 || return 2
62         # Add code here, if necessary, that waits for the process to be ready
63         # to handle requests from services started subsequently which depend
64         # on this one.  As a last resort, sleep for some time.
65 }
66
67 #
68 # Function that stops the daemon/service
69 #
70 do_stop()
71 {
72         # Return
73         #   0 if daemon has been stopped
74         #   1 if daemon was already stopped
75         #   2 if daemon could not be stopped
76         #   other if a failure occurred
77         start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
78         RETVAL="$?"
79         [ "$RETVAL" = 2 ] && return 2
80         # Wait for children to finish too if this is a daemon that forks
81         # and if the daemon is only ever run from this initscript.
82         # If the above conditions are not satisfied then add some other code
83         # that waits for the process to drop all resources that could be
84         # needed by services started subsequently.  A last resort is to
85         # sleep for some time.
86         start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
87         [ "$?" = 2 ] && return 2
88         # Many daemons don't delete their pidfiles when they exit.
89         rm -f $PIDFILE
90         return "$RETVAL"
91 }
92
93 #
94 # Function that sends a SIGHUP to the daemon/service
95 #
96 do_reload() {
97         #
98         # If the daemon can reload its configuration without
99         # restarting (for example, when it is sent a SIGHUP),
100         # then implement that here.
101         #
102         start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
103         return 0
104 }
105
106 case "$1" in
107   start)
108         [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
109         do_start
110         case "$?" in
111                 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
112                 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
113         esac
114         ;;
115   stop)
116         [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
117         do_stop
118         case "$?" in
119                 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
120                 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
121         esac
122         ;;
123   status)
124         status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
125         ;;
126   #reload|force-reload)
127         #
128         # If do_reload() is not implemented then leave this commented out
129         # and leave 'force-reload' as an alias for 'restart'.
130         #
131         #log_daemon_msg "Reloading $DESC" "$NAME"
132         #do_reload
133         #log_end_msg $?
134         #;;
135   restart|force-reload)
136         #
137         # If the "reload" option is implemented then remove the
138         # 'force-reload' alias
139         #
140         log_daemon_msg "Restarting $DESC" "$NAME"
141         do_stop
142         case "$?" in
143           0|1)
144                 do_start
145                 case "$?" in
146                         0) log_end_msg 0 ;;
147                         1) log_end_msg 1 ;; # Old process is still running
148                         *) log_end_msg 1 ;; # Failed to start
149                 esac
150                 ;;
151           *)
152                 # Failed to stop
153                 log_end_msg 1
154                 ;;
155         esac
156         ;;
157   *)
158         #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
159         echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
160         exit 3
161         ;;
162 esac
163
164 :